/**********************************************************
* BASICAPP.C: A basic Windows application.
**********************************************************/

#include <windows.h>

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
    WPARAM wParam, LPARAM lParam);

int WINAPI WinMain(HINSTANCE hCurrentInst,
    HINSTANCE hPrevInstance, PSTR lpszCmdLine,
    int nCmdShow)
{
    WNDCLASS wndClass;
    HWND hWnd;
    MSG msg;
	UINT width;
	UINT height;

    wndClass.style = CS_HREDRAW | CS_VREDRAW;
    wndClass.lpfnWndProc = WndProc;
    wndClass.cbClsExtra = 0;
    wndClass.cbWndExtra = 0;
    wndClass.hInstance = hCurrentInst;
    wndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
    wndClass.hbrBackground = GetStockObject(WHITE_BRUSH);
    wndClass.lpszMenuName = NULL;
    wndClass.lpszClassName = "BasicApp";

    RegisterClass(&wndClass);

    width = GetSystemMetrics(SM_CXSCREEN) / 2;
    height = GetSystemMetrics(SM_CYSCREEN) / 2;

    hWnd = CreateWindow(
               "BasicApp",           /* Window class's name.    */
               "Basic Application",  /* Title bar text.         */
               WS_OVERLAPPEDWINDOW,  /* The window's style.     */
               10,                   /* X position.             */
               10,                   /* Y position.             */
               width,                /* Width.                  */
               height,               /* Height.                 */
               NULL,                 /* Parent window's handle. */
               NULL,                 /* Menu handle.            */
               hCurrentInst,         /* Instance handle.        */
               NULL);                /* No additional data.     */

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
    WPARAM wParam, LPARAM lParam)
{
    HDC hDC;
    PAINTSTRUCT paintStruct;

    switch(message)
    {
        case WM_PAINT:
            hDC = BeginPaint(hWnd, &paintStruct);
            TextOut(hDC, 10, 10, "This is a test.", 15);
            EndPaint(hWnd, &paintStruct);
            return 0;

        case WM_LBUTTONDOWN:
			MessageBox(hWnd, "Got mouse click!",
				"Basic Application",
				MB_ICONEXCLAMATION | MB_OK);
			return 0;

        case WM_DESTROY:
            PostQuitMessage(0);
            return 0;
    }

    return DefWindowProc(hWnd, message, wParam, lParam);
}
